#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_RoomRewardCFG.h"
std::auto_ptr<M_RoomRewardCFG> M_RoomRewardCFG::msSingleton(nullptr);

int M_RoomRewardCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_RoomRewardCFGData* M_RoomRewardCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_RoomRewardCFGData>& M_RoomRewardCFG::GetMapData()
{
	return mMapData;
}

void M_RoomRewardCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_RoomRewardCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_RoomRewardCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mType = element->IntAttribute("Type");
		data.mNeedItem = element->IntAttribute("NeedItem");
		data.mNeedCount = element->IntAttribute("NeedCount");
		{
			const char* RewardItems = element->Attribute("RewardItems");
			std::vector<std::string> vecRewardItems;
			boost::split(vecRewardItems, RewardItems, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRewardItems.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRewardItems[i].c_str(), &temp))
				{
					data.mRewardItems.push_back(temp);
				}
			}
		}
		{
			const char* RewardCount = element->Attribute("RewardCount");
			std::vector<std::string> vecRewardCount;
			boost::split(vecRewardCount, RewardCount, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRewardCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRewardCount[i].c_str(), &temp))
				{
					data.mRewardCount.push_back(temp);
				}
			}
		}
		{
			const char* GiftRewardItems = element->Attribute("GiftRewardItems");
			std::vector<std::string> vecGiftRewardItems;
			boost::split(vecGiftRewardItems, GiftRewardItems, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecGiftRewardItems.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecGiftRewardItems[i].c_str(), &temp))
				{
					data.mGiftRewardItems.push_back(temp);
				}
			}
		}
		{
			const char* GiftRewardCount = element->Attribute("GiftRewardCount");
			std::vector<std::string> vecGiftRewardCount;
			boost::split(vecGiftRewardCount, GiftRewardCount, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecGiftRewardCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecGiftRewardCount[i].c_str(), &temp))
				{
					data.mGiftRewardCount.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_RoomRewardCFG Loaded. Load Data:%u", mMapData.size());
}

void M_RoomRewardCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_RoomRewardCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_RoomRewardCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_RoomRewardCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "Type", data.mType);
		LuaCfgHelper::readInt(L, "NeedItem", data.mNeedItem);
		LuaCfgHelper::readInt(L, "NeedCount", data.mNeedCount);
		LuaCfgHelper::readVectorInt(L, "RewardItems", data.mRewardItems);
		LuaCfgHelper::readVectorInt(L, "RewardCount", data.mRewardCount);
		LuaCfgHelper::readVectorInt(L, "GiftRewardItems", data.mGiftRewardItems);
		LuaCfgHelper::readVectorInt(L, "GiftRewardCount", data.mGiftRewardCount);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_RoomRewardCFG Loaded. Load Data:%u", mMapData.size());
}

void M_RoomRewardCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_RoomRewardCFG* M_RoomRewardCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_RoomRewardCFG());
	}
	return msSingleton.get();
}

void M_RoomRewardCFG::Release()
{
	msSingleton.reset(nullptr);
}
